Subject: PersistenceManager chokes on empty uploads
Description

Given following setup:

Domain/Model/SomeObject.php
 1/**
 2 * @FLOW3\Entity
 3 */
 4class SomeObject {
 5
 6    /**
 7     * @var \Doctrine\Common\Collections\ArrayCollection<\TYPO3\FLOW3\Resource\Resource>
 8     * @ORM\ManyToMany
 9     */
10    protected $resources;
11
12    // ...
13
14}

Template.html
1<f:form method="post" action="create" object="{newObject}" objectName="newObject" enctype="multipart/form-data">
2    <f:form.upload property="resources.0" />
3    <f:form.upload property="resources.1" />
4    <f:form.submit value="Create"/>
5</f:form>

If you submit the form, following exception is thrown:

#1337934455: Could not add object of type "MyPackage\Domain\Model\SomeObject" (in PersistenceManager:264)
Warning: spl_object_hash() expects parameter 1 to be object, null given in
Packages/Framework/Doctrine.ORM/Classes/UnitOfWork.php line 1509
A similar problem occurs when adding an intermediate object like "File" as OneToMany relation which contains a relation to one
resource:

Domain/Model/SomeObject.php
 1/**
 2 * @FLOW3\Entity
 3 */
 4class SomeObject {
 5
 6    /**
 7     * @var \Doctrine\Common\Collections\ArrayCollection<\TYPO3\FLOW3\Resource\Resource>
 8     * @ORM\OneToMany(mappedBy="someObject",cascade={"all"})
 9     */
10    protected $files;
11
12    // ...
13
14}

Template.html
1<f:form method="post" action="create" object="{newObject}" objectName="newObject" enctype="multipart/form-data">
2    <f:form.upload property="files.0.originalResource" />
3    <f:form.upload property="files.1.originalResource" />
4    <f:form.submit value="Create"/>
5</f:form>

In that case the exception is thrown while property mapping already:

#1297759968: Exception while property mapping for target type "MyPackage\Domain\Model\SomeObject", at property path
"files.0": Catchable Fatal Error: Argument 1 passed to MyPackage\Domain\Model\File::setOriginalResource() must be an
instance of TYPO3\FLOW3\Resource\Resource, null given, called in
Packages/Framework/TYPO3.FLOW3/Classes/Reflection\ObjectAccess.php on line 182

So, I'm not sure if that's a problem of the property mapper or the persistence actually. But this was not present before and is a blocker
IMO

Associated revisions
Revision 38fcda54 - 2012-06-20 16:08 - Bastian Waidelich

[BUGFIX] Only map file uploads to arguments if not empty

Currently the HTTP request converts the FILES superglobal
to request arguments even if no file has been uploaded.
This leads to an exception when submitting a form without
uploading a file because the property mapper receives a
corrupt source array in that case.
This adjust the HTTP request to only map values from the
FILES superglobal to arguments if a file has been uploaded.

This also tweaks the ResourceTypeConverter to accept
an empty source. Besides the converter now only outputs
filer errors (for too large or corrupt files) to the user.
Server errors (e.g. non-existing/read-only tmp directory)
are logged to the systemLogger.

Change-Id: I31519231086cd71feff73ff675806d0382ae6b40
Fixes: #38184
Releases: 1.1, 1.2

Revision 4441c3cb - 2012-06-20 17:51 - Bastian Waidelich

[BUGFIX] Only map file uploads to arguments if not empty

Currently the HTTP request converts the FILES superglobal
to request arguments even if no file has been uploaded.
This leads to an exception when submitting a form without
uploading a file because the property mapper receives a
corrupt source array in that case.

This adjust the HTTP request to only map values from the
FILES superglobal to arguments if a file has been uploaded.

This also tweaks the ResourceTypeConverter to accept
an empty source. Besides the converter now only outputs
filer errors (for too large or corrupt files) to the user.
Server errors (e.g. non-existing/read-only tmp directory)
are logged to the systemLogger.

Change-Id: I718893e38204ceef2d5ed13e48c17bccf0f226b6
Fixes: #38184
Releases: 1.1, 1.2

History
#1 - 2012-06-20 09:41 - Bastian Waidelich

Update: This is most probably a regression introduced with https://review.typo3.org/#/c/11709/1

#2 - 2012-06-20 09:41 - Bastian Waidelich
- Category changed from Persistence to Property

#3 - 2012-06-20 11:14 - Karsten Dambekalns
- Assigned To set to Bastian Waidelich

#4 - 2012-06-20 11:14 - Karsten Dambekalns
- Status changed from New to Accepted
#5 - 2012-06-20 14:29 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/12216

#6 - 2012-06-20 16:08 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/12216

#7 - 2012-06-20 16:37 - Bastian Waidelich
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:38fcda543a3c4ad0600fdba19c6fbd31da895e20.

#8 - 2012-06-20 17:51 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch FLOW3-1.1 has been pushed to the review server.
It is available at http://review.typo3.org/12228

#9 - 2012-06-21 10:38 - Bastian Waidelich
- Status changed from Under Review to Resolved

Applied in changeset commit:4441c3cb94079e602bcfbebc3c7e10cb95d32b53.
